<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="html" encoding="ISO-8859-1"/>

  <xsl:template match="/order">
    <html>
      <head>
        <title>your order</title>
      </head>
      <body>
        <table width="100%">
          <tr>
            <th width="40%" align="left">Item</th>
            <th width="20%" align="left">Quantity</th>
            <th width="20%" align="left">Price per Unit</th>
            <th width="20%" align="left">Total</th>
          </tr>
          <xsl:call-template name="total">
            <xsl:with-param name="items" select="item"/>
          </xsl:call-template>
        </table>
      </body>
    </html>
  </xsl:template>

  <xsl:template name="total">
    <xsl:param name="items"/>
    <xsl:param name="sum" select="0"/>
    <xsl:choose>
      <xsl:when test="$items">
        <xsl:variable name="name" select="$items[1]/name"/>
        <xsl:variable name="quant" select="$items[1]/quant"/>
        <xsl:variable name="price" select="$items[1]/price"/>
        <tr>
          <td><xsl:value-of select="$name"/></td>
          <td><xsl:value-of select="$quant"/></td>
          <td><xsl:value-of select="$price"/></td>
          <td><xsl:value-of select="$price * $quant"/></td>
        </tr>
        <xsl:call-template name="total">
          <xsl:with-param name="items" select="$items[position()!=1]"/>
          <xsl:with-param name="sum" select="$sum + $price * $quant"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <tr>
          <td><b>TOTAL</b></td>
          <td>&#160;</td>
          <td>&#160;</td>
          <td><b><xsl:value-of select="$sum"/></b></td>
        </tr>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

</xsl:stylesheet>