<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:exslt="http://exslt.org/common">
  <xsl:output method="html" encoding="ISO-8859-1"/>

  <xsl:template match="/soccerchamps">
    <xsl:variable name="countlist">
      <xsl:call-template name="countchamps"/>
    </xsl:variable>
    <html>
      <head>
        <title>Fu&#xDF;ballmeister</title>
      </head>
      <body>
        <h1>Deutsche Meisterschaften im Fu&#xDF;ball</h1>
        <table>
          <xsl:for-each select="exslt:node-set($countlist)/team">
            <xsl:sort select="@number" data-type="number" order="descending"/>
            <tr>
              <td><xsl:value-of select="."/></td>
              <td><xsl:value-of select="@number"/> championships</td>
            </tr>
          </xsl:for-each>
        </table>
      </body>
    </html>
  </xsl:template>

  <xsl:template name="countchamps">
    <xsl:for-each select="/soccerchamps/champ[not(.=preceding::champ)]">
      <xsl:variable name="team" select="."/>
      <team>
        <xsl:attribute name="number">
          <xsl:value-of select="count(/soccerchamps/champ[.=$team])"/>
        </xsl:attribute>
        <xsl:value-of select="$team"/>
      </team>
    </xsl:for-each>
  </xsl:template>

</xsl:stylesheet>
